<?php

namespace Modules\Address\Requests\Admin;

use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Request;
use Illuminate\Foundation\Http\FormRequest;
use Illuminate\Validation\Rule;
use Illuminate\Validation\ValidationException;
use Illuminate\Contracts\Validation\Validator;
use Illuminate\Http\Exceptions\HttpResponseException;
use Modules\User\Enums\UserRoleEnum;

class AddressRequest extends FormRequest
{
    /**
     * Determine if the user is authorized to make this request.
     *
     * @return bool
     */
    public function authorize()
    {
        $role = UserRoleEnum::admins();
        if (!Auth::check()) {
            return false;
        }
        if (!in_array(Auth::user()->role, $role)) {
            return false;
        }
        if (Auth::user()->hasModule('canteens')) {
            return true;
        }
        return Auth::check();
    }

    /**
     * Get the validation rules that apply to the request.
     *
     * @return array
     */
    public function rules()
    {
        $rules =
        [
            'user_id'=>
            [
                'required',
                Rule::exists('users','id')->whereNull('deleted_at')
            ],
            'city_id'=>
            [
                'required',
                Rule::exists('cities','id')->whereNull('deleted_at')
            ],
            'description'=> 
            [
                'required',
                'string',
                'max:50'
            ],
            'latitude'=>
            [
                'nullable'
            ],
            'longitude'=>
            [
                'nullable'
            ],
        ];
        
        if(!request('latitude') || !request('longitude'))
        {
            $rules['map'] = 'required';
        }


        return $rules;
    }

    /**
     * Get custom attributes for validator errors.
     *
     * @return array
     */
    public function attributes()
    {

        $attributes = 
        [
            'city_id'=>__('addresses.city_id'),
            'description'=>__('addresses.description'),
            'map'=>__('addresses.map'),
            'user_id'=>__('addresses.user_id'),
        ];
        
        return $attributes;
    }

    /**
     * Handle a failed validation attempt.
     *
     * Override the parent method action if the request is for AJAX
     *
     * @param Validator $validator
     * @return void
     *
     * @throws ValidationException
     */
    protected function failedValidation(Validator $validator)
    {
        // Change response attitude if the request done via Ajax requests like API requests
        if(Request::wantsJson()){
            $errors = (new ValidationException($validator))->errors();
            throw new HttpResponseException(response()->json(['errors' => $errors], 422));
        } else {
            // Do the original action of the Form request class
            parent::failedValidation($validator);
        }
    }
}
